> This page is for version v1.3 (default).
> For other versions, use one of these documentation indexes:
> - v1.3 (default): https://docs.twelvelabs.io/v1.3/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.twelvelabs.io/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.twelvelabs.io/_mcp/server.

# Create an item tag

POST https://api.twelvelabs.io/v1.3/knowledge-stores/{knowledge_store_id}/items/{item_id}/tags
Content-Type: application/json

This method tags a moment or a range of a video item and returns the tag. Set `start_sec` to tag a moment. Set `start_sec` and `end_sec` to tag a range. A video item holds up to 100 tags. The method returns a 422 error for an item that is not a video item, and when the item already holds 100 tags.


Reference: https://docs.twelvelabs.io/api-reference/knowledge-store-items/item-tags/create

## Authentication

- `x-api-key` header (required) — Your API key. You can find your API key on the API Keys page.

## Request

### Path parameters

- `knowledge_store_id` (string, required) — The unique identifier of the knowledge store.
- `item_id` (string, required) — The unique identifier of the knowledge store item.

### Body (application/json)

This endpoint expects a CreateKnowledgeStoreItemTagRequest.

- `start_sec` (double, required) — The start of the tag, in seconds from the start of the video. It must be less than the duration of the video.
- `tag_metadata` (map from string to KnowledgeStoreMetadataValue, required) — The custom metadata of the tag, as key-value pairs. Send at least one key. Up to 50 pairs. Keys are strings of up to 128 characters. String values can have up to 8192 characters. Values can be a string, a number, a boolean, or an array of strings. A nested object, an array containing anything other than strings, and a null value are rejected. An integer must fit in 53 bits (-9007199254740991 to 9007199254740991). Send a wider integer, or an identifier that must be preserved verbatim, as a string.
- `end_sec` (double, optional, nullable) — The end of the range, in seconds from the start of the video. It must be greater than `start_sec`. It must not exceed the duration of the video. Omit it, or send `null`, to tag a single moment.

## Response

### 201

The item tag has been successfully created.

- `_id` (string, required) — The unique identifier of the item tag.
- `knowledge_store_id` (string, required) — The unique identifier of the knowledge store.
- `item_id` (string, required) — The unique identifier of the knowledge store item that holds the tag.
- `start_sec` (double, required) — The start of the tag, in seconds from the start of the video.
- `end_sec` (double, required, nullable) — The end of the range, in seconds from the start of the video. The value is `null` for a tag on a single moment.
- `tag_metadata` (map from string to KnowledgeStoreMetadataValue, required) — The custom metadata of the tag. Keys are strings. Each value is a string, a number, a boolean, or an array of strings.
- `created_at` (string, required) — The date and time when the tag was created, in the RFC 3339 format.
- `updated_at` (string, required) — The date and time when the tag was last updated, in the RFC 3339 format.

## Errors

### 400 Bad Request Error

The request has failed.

- `code` (string, optional) — A string representing the code associated with the error. See the [Error codes](/v1.3/api-reference/error-codes) page for details.
- `message` (string, optional) — A human-readable string describing the error, intended to be suitable for display in a user interface.

### 404 Not Found Error

The specified resource does not exist.

- `code` (string, optional) — Represents the code associated with the error. See the [Error codes](/v1.3/api-reference/error-codes) page for details.
- `message` (string, optional) — A human-readable string describing the error.

### 422 Unprocessable Entity Error

The request has failed. For example, the item is not a video item, the item already holds 100 tags, the range does not end after it starts, or the range exceeds the duration of the video.

- `code` (string, required) — A string representing the code associated with the error. See the [Error codes](/v1.3/api-reference/error-codes) page for details.
- `message` (string, required) — A human-readable string describing the error, intended to be suitable for display in a user interface.

## Types

### KnowledgeStoreMetadataValue

A single custom-metadata value: a string, a number, a boolean, or an array of strings. The value keeps the JSON type sent; a nested object, an array containing anything other than strings, and a null value are rejected. An integer must fit in 53 bits (-9007199254740991 to 9007199254740991). A wider integer, or an identifier that must be preserved verbatim, must be sent as a string.

## Examples

**Request**

```json
{
  "start_sec": 12.5,
  "tag_metadata": {
    "event": "goal",
    "team": "home"
  },
  "end_sec": 18.25
}
```

**Response**

```json
{
  "_id": "ksit_069e9870-3c4d-7abc-9012-3456789abcde",
  "knowledge_store_id": "ks_069e9869-1ea3-7481-8000-dae72bf6be6e",
  "item_id": "ksi_069e9870-3c4d-7abc-9012-3456789abcde",
  "start_sec": 12.5,
  "end_sec": 18.25,
  "tag_metadata": {
    "event": "goal",
    "team": "home"
  },
  "created_at": "2024-01-15T09:30:00Z",
  "updated_at": "2024-01-15T09:30:00Z"
}
```

**SDK Code**

```python
import requests

url = "https://api.twelvelabs.io/v1.3/knowledge-stores/ks_069e9869-1ea3-7481-8000-dae72bf6be6e/items/ksi_069e9870-3c4d-7abc-9012-3456789abcde/tags"

payload = {
    "start_sec": 12.5,
    "tag_metadata": {
        "event": "goal",
        "team": "home"
    },
    "end_sec": 18.25
}
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.twelvelabs.io/v1.3/knowledge-stores/ks_069e9869-1ea3-7481-8000-dae72bf6be6e/items/ksi_069e9870-3c4d-7abc-9012-3456789abcde/tags';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"start_sec":12.5,"tag_metadata":{"event":"goal","team":"home"},"end_sec":18.25}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.twelvelabs.io/v1.3/knowledge-stores/ks_069e9869-1ea3-7481-8000-dae72bf6be6e/items/ksi_069e9870-3c4d-7abc-9012-3456789abcde/tags"

	payload := strings.NewReader("{\n  \"start_sec\": 12.5,\n  \"tag_metadata\": {\n    \"event\": \"goal\",\n    \"team\": \"home\"\n  },\n  \"end_sec\": 18.25\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.twelvelabs.io/v1.3/knowledge-stores/ks_069e9869-1ea3-7481-8000-dae72bf6be6e/items/ksi_069e9870-3c4d-7abc-9012-3456789abcde/tags")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"start_sec\": 12.5,\n  \"tag_metadata\": {\n    \"event\": \"goal\",\n    \"team\": \"home\"\n  },\n  \"end_sec\": 18.25\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.twelvelabs.io/v1.3/knowledge-stores/ks_069e9869-1ea3-7481-8000-dae72bf6be6e/items/ksi_069e9870-3c4d-7abc-9012-3456789abcde/tags")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"start_sec\": 12.5,\n  \"tag_metadata\": {\n    \"event\": \"goal\",\n    \"team\": \"home\"\n  },\n  \"end_sec\": 18.25\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.twelvelabs.io/v1.3/knowledge-stores/ks_069e9869-1ea3-7481-8000-dae72bf6be6e/items/ksi_069e9870-3c4d-7abc-9012-3456789abcde/tags', [
  'body' => '{
  "start_sec": 12.5,
  "tag_metadata": {
    "event": "goal",
    "team": "home"
  },
  "end_sec": 18.25
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.twelvelabs.io/v1.3/knowledge-stores/ks_069e9869-1ea3-7481-8000-dae72bf6be6e/items/ksi_069e9870-3c4d-7abc-9012-3456789abcde/tags");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"start_sec\": 12.5,\n  \"tag_metadata\": {\n    \"event\": \"goal\",\n    \"team\": \"home\"\n  },\n  \"end_sec\": 18.25\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "start_sec": 12.5,
  "tag_metadata": [
    "event": "goal",
    "team": "home"
  ],
  "end_sec": 18.25
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.twelvelabs.io/v1.3/knowledge-stores/ks_069e9869-1ea3-7481-8000-dae72bf6be6e/items/ksi_069e9870-3c4d-7abc-9012-3456789abcde/tags")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```